// test4.c

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
                  
typedef struct _TEST_PAD {
    int GlobalInt1;
    int Fill[8];
    int GlobalInt2;
} TEST_PAD;

HANDLE T1,T2;
TEST_PAD data;


#ifdef __BORLANDC__
#   pragma argsused
#endif
DWORD WINAPI Thread1(LPVOID Arg)
{
    while (data.GlobalInt1 < 0xFFFFFFF/2) {
        data.GlobalInt1++;
    }
    return 0;
} 

DWORD WINAPI Thread2(LPVOID Arg)
{
    while (data.GlobalInt2 < 0xFFFFFFF/2) {
        data.GlobalInt2++;
    }
    return 0;
} 

int main(int argc, char *argv[])
{
    DWORD   Id, pAff, sAff;
    DWORD   startTime = 0, stopTime = 0;
    
    if (argc <= 1) {
       printf("ERROR: Requires affinity parameter (0,1,2)\n");
       return EXIT_FAILURE;
    }

    T1 = CreateThread(0, 0, Thread1, 0, 0, &Id);
    T2 = CreateThread(0, 0, Thread2, 0, 0, &Id);

    GetProcessAffinityMask(GetCurrentProcess(), &pAff, &sAff);
    
    if (*argv[1] == '1') {
        SetThreadAffinityMask(T1, 0x01);
        SetThreadAffinityMask(T2, 0x01);
    } else if ((*argv[1] == '2') && (pAff & 0x3)) {
       SetThreadAffinityMask(T1, 0x01);
       SetThreadAffinityMask(T2, 0x02);
    } else {
        // don't alter affinity, go with default scheduling
    }
   
    startTime = GetTickCount();

    WaitForSingleObject(T1, INFINITE);
    WaitForSingleObject(T2, INFINITE);
    
    stopTime = GetTickCount();
    printf("Test Run (%c) Duration = %d msec\n", 
           *argv[1], stopTime - startTime);
    return EXIT_SUCCESS;
}

